<template>
  <div
    class="mt-1 h-auto overflow-hidden bg-ec-other-white shadow-md transition-[max-height] duration-500"
    :class="{
      'max-h-0 border-0': !isOpen,
      'max-h-[700px] overflow-y-auto border border-t-0': isOpen,
    }"
  >
    <div
      :tabindex="isOpen ? 0 : undefined"
      v-for="(option, index) in options"
      :key="option.key"
      :value="option.key"
      class="cursor-pointer px-4 py-2 hover:bg-ec-primary-20"
      :class="{ 'active bg-ec-primary-20': activeOption === index }"
      @click="$emit('select', option.key)"
      @focus="$emit('select', option.key)"
      @blur="activeOption = null"
    >
      <slot name="option" :label="option.label" :key="option.key">
        <div>{{ option.label }}</div>
      </slot>
    </div>
  </div>
</template>

<script setup lang="ts">
import { type PropType, ref, watch } from 'vue';

const emit = defineEmits<{
  (e: 'select', key: string): void;
  (e: 'activeOption', key: string | null): void;
}>();

const activeOption = ref<number | null>(null);

const props = defineProps({
  isOpen: {
    type: Boolean,
    default: false,
  },
  options: {
    type: Array as PropType<{ label: string; key: string }[]>,
    default: [],
  },
});

const incrementActiveOption = (amount: number = 1) => {
  if (!props.isOpen) return;

  if (activeOption.value === null || activeOption.value + amount > props.options.length - 1) {
    activeOption.value = 0;
  } else if (activeOption.value + amount < 0) {
    activeOption.value = props.options.length - 1;
  } else {
    activeOption.value! += amount;
  }

  emit('activeOption', props.options[activeOption.value].key);
};

defineExpose({
  incrementActiveOption,
});
</script>
